/*
 * Chapter 21
 * Task 3: Handling pushbuttons with interrupts
 *
 * The 3 LEDs connected to PA0,1,2 pins show a 3 digit counter
 * With pushbuttons connected to PD2 and PD3 the value can be incremented or decremented
 * When a button is released, the rising edge on the input generates an interrupt
 */

#include "../Headers/main.h"

volatile uint8_t cntr = 0;

//Interrupt for increment button
ISR(INT0_vect)
{
	//If counter smaller than 7 (maximum)
	if (cntr < 7)
	{
		//Increment
		cntr++;
	}
}

//Interrupt for decrement button
ISR(INT1_vect)
{
	//If counter larger than 0 (minimum)
	if (cntr > 0)
	{
		//Decrement
		cntr--;
	}
}

int main(void)
{
	//Initializing IO ports
	IOInit();

	//Infinite loop
	while (1)
	{
		//Set LED states connected to PA0,1,2 to be equal with counter
		PORTA = cntr;
	}

	return (0);
}
